function find_optimized_parameters(num_constrains,energy_kind,rand,number_iterations)
%% get the best corrs
corrs = nan(number_iterations,1);
corrs_rand = nan(number_iterations,1);
for start=1:number_iterations
    if energy_kind == 1
        load(sprintf('res_fold_start%d_%d.mat',start,num_constrains))
        corrs(start) = corr_cur;
        load(sprintf('res_fold_rand%d_start%d_%d.mat',rand,start,num_constrains))
        corrs_rand(start) = corr_cur;
    elseif energy_kind == 2   
        load(sprintf('res_cofold_start%d_%d.mat',start,num_constrains))
        corrs(start) = corr_cur;
        load(sprintf('res_cofold_rand%d_start%d_%d.mat',rand,start,num_constrains))
        corrs_rand(start) = corr_cur;
    else
        load(sprintf('%sres_minusfold_start%d_%d.mat',path2,start,num_constrains))
        corrs(start) = corr_cur;
        load(sprintf('%sres_minusfold_rand%d_start%d_%d.mat',path2,rand,start,num_constrains))
        corrs_rand(start) = corr_cur;
    end
end

if energy_kind == 1
    [~,which_best_corr]=nanmax(corrs);
    [~,which_best_corr_rand]=nanmax(corrs_rand);
else
    [~,which_best_corr]=nanmin(corrs);
    [~,which_best_corr_rand]=nanmin(corrs_rand);
end

energy_names = {'fold','cofold','ETIP'};
save(sprintf('%s_train_corrs.mat',energy_names{energy_kind}),'corrs','which_best_corr','corrs_rand','which_best_corr_rand')

end

