number_iterations = 50;
num_constrains = [0,3:2:14];
rand = 1;
energy_names = {'fold','cofold','ETIP'};

for n = 1:length(num_constrains)
    for energy_kind = [1,2,3]
        % find optimized parameters for every constrains option
        find_optimized_parameters(num_constrains(n),energy_kind,rand,number_iterations);
    end
end

% fold test
energy_kind = 1;
load('fold_train_corrs.mat')

[~,best_constrains_fold_ind] = max(corr(:,energy_kind));
best_constrains_fold = num_constrains(best_constrains_fold_ind);
save('best_constrains_fold','best_constrains_fold')
best_start_fold = which_fold;
save('best_start_fold','best_start_fold')

[~,best_constrains_fold_ind_rand] = max(corr_rand(:,energy_kind));
best_constrains_fold_rand = num_constrains(best_constrains_fold_ind_rand);
save('best_constrains_fold_rand','best_constrains_fold_rand')
best_start_fold_rand = which_fold_rand;
save('best_start_fold_rand','best_start_fold_rand')
% calculate test corrs:
energy_name = energy_names{energy_kind};
create_energy_CAI_corr_test(energy_kind,energy_name,best_start_fold,best_start_fold_rand,best_constrains_fold,best_constrains_fold_rand);

% cofold test
energy_kind = 2;
load('cofold_train_corrs.mat')

[~,best_constrains_cofold_ind] = max(corr(:,energy_kind));
best_constrains_cofold = num_constrains(best_constrains_cofold_ind);
save('best_constrains_cofold','best_constrains_cofold')
best_start_cofold = which_cofold;
save('best_start_cofold','best_start_cofold')

[~,best_constrains_cofold_ind_rand] = max(corr_rand(:,energy_kind));
best_constrains_cofold_rand = num_constrains(best_constrains_cofold_ind_rand);
save('best_constrains_cofold_rand','best_constrains_cofold_rand')
best_start_cofold_rand = which_cofold_rand;
save('best_start_cofold_rand','best_start_cofold_rand')
% calculate test corrs:
energy_name = energy_names{energy_kind};
create_energy_CAI_corr_test(energy_kind,energy_name,best_start_cofold,best_start_cofold_rand,best_constrains_cofold,best_constrains_cofold_rand);

% ETIP test
energy_kind = 3;
load('ETIP_train_corrs.mat')

[~,best_constrains_ETIP_ind] = max(corr(:,energy_kind));
best_constrains_ETIP = num_constrains(best_constrains_ETIP_ind);
save('best_constrains_ETIP','best_constrains_ETIP')
best_start_ETIP = which_ETIP;
save('best_start_ETIP','best_start_ETIP')

[~,best_constrains_ETIP_ind_rand] = max(corr_rand(:,energy_kind));
best_constrains_ETIP_rand = num_constrains(best_constrains_ETIP_ind_rand);
save('best_constrains_ETIP_rand','best_constrains_ETIP_rand')
best_start_ETIP_rand = which_ETIP_rand;
save('best_start_ETIP_rand','best_start_ETIP_rand')
% calculate test corrs:
energy_name = energy_names{energy_kind};
create_energy_CAI_corr_test(energy_kind,energy_name,best_start_ETIP,best_start_ETIP_rand,best_constrains_ETIP,best_constrains_ETIP_rand);


