function Entropy = Entropy_MSA(MSA_nt_num)
numGenes = length(MSA_nt_num);
numNt = length(MSA_nt_num{1});
Entropy = zeros(numNt,1);
if iscell(MSA_nt_num)
    MSA_nt_num_num = zeros(numGenes,numNt); 
    for g = 1:numGenes
        MSA_nt_num_num(g,:) = nt2int(MSA_nt_num{g});
    end
else
    MSA_nt_num_num = MSA_nt_num;
end
for col = 1:numNt
    cur_entropy = 0;
    symbols = unique(MSA_nt_num_num(:,col));
    amount_symbols = length(symbols);
    for nt = 1:amount_symbols
        c_nt = sum(MSA_nt_num_num(:,col)==symbols(nt));
        cur_entropy = cur_entropy -(c_nt/numGenes)*log((c_nt/numGenes));
    end
    Entropy(col) =cur_entropy;
end

