function cofold_energy_mat = cofold_mat_calc(mRNA_l,S16_l,genes,Seq_16S_c,r,pos)
 am_genes=length(genes);       
    if iscell(Seq_16S_c)
        seq_16S_cur_all=upper(Seq_16S_c{r});
    else
        seq_16S_cur_all=upper(Seq_16S_c);
    end
    seq_16S_cur=(seq_16S_cur_all(end-S16_l+1:end));


    % sequence for text
    [seq_cofold] = create_cofold_seq(genes,mRNA_l,seq_16S_cur,pos);

    % create text file
    fid = fopen(sprintf('cofold%d_%d_%d.txt',mRNA_l,S16_l,r),'wt');
    fprintf(fid,'%s\n',seq_cofold{:});
    fclose(fid);

    % energy value
    [~,output] = system(sprintf('./RNAcofold -d2 < cofold%d_%d_%d.txt',mRNA_l,S16_l,r));
    energy = (regexp(output,'-?\d+\.\d*','match'));

    count_genes=0;
    p=1;
    cofold_energy_mat=zeros(am_genes,pos);
    for en=1:length(energy)
        if count_genes==am_genes
            p=p+1;
            count_genes=0;
        end
        count_genes=count_genes+1;    
        cofold_energy_mat(count_genes,p)=str2num(energy{en});
    end
end