function [energies_vec,corr_cur] = create_energy_CAI_corr_test(energy_kind,energy_name,which_best_corr,which_best_corr_rand,which_best_constrains,which_best_constrains_rand)
    load(sprintf('%s_train_corrs.mat',energy_name))
    load('group_ind_test.mat'); load('am_genes_test.mat'); load('right_places_test.mat');
    group_ind = group_ind_test; am_genes = am_genes_test; right_places = right_places_test;   
    load('test_c_for_g.mat')
    load('fold_16S.mat')
    load('number_groups.mat')
    
    % real
    which_best = which_best_corr;
    load(sprintf('res_%s_start%d_%d.mat',energy_name,which_best,which_best_constrains))
    energies_vec = zeros(am_genes,1);

    for gr = 1:number_groups
        if energy_kind == 1
            load(sprintf('gr%d_fold_%d.mat',gr,params{i}(1)))   
        elseif energy_kind == 2
            load(sprintf('gr%d_cofold_%d_%d.mat',gr,params{i}(1),params{i}(2))) 
        elseif energy_kind == 3
            load(sprintf('gr%d_fold_%d.mat',gr,params{i}(1))) 
            load(sprintf('gr%d_cofold_%d_%d.mat',gr,params{i}(1),params{i}(2))) 
        end
        for gene = 1:length(group_ind{i})
            right_place = right_places{i}(gene);
            gene_i = group_ind{i}(gene);
            if energy_kind == 1
                energies_vec(right_place) = group_fold_new.Fold{gene_i}(params{i}(2)); 
            elseif energy_kind == 2
                energies_vec(right_place) = group_cofold_new.CoFold{gene_i}(params{i}(3)); 
            elseif energy_kind == 3
                chloro = test_c_for_g(right_place);
                energies_vec(right_place) = group_cofold_new.CoFold{gene_i}(params{i}(3))-params{i}(4)*(group_fold_new.Fold{gene_i}(params{i}(2))+fold_16S2(chloro,params{i}(2)-20+1)); 
            end
            load('vectorized_CAI_test.mat')
        end
    end
    no_nans_vec = energies_vec(~isnan(energies_vec));
    no_nans_CAI = vectorized_CAI(~isnan(energies_vec));
    [corr_cur,~] = corr(no_nans_vec,no_nans_CAI,'Type','Spearman');

    save(sprintf('test_%s_%d.mat',energy_name,num_constrains),'energies_vec','corr_cur')

    % rand
    which_best = which_best_corr_rand;
    load(sprintf('res_%s_rand%d_start%d_%d.mat',energy_name,rand,which_best,which_best_constrains_rand))
    energies_vec = zeros(am_genes,1);

    for gr = 1:number_groups
        if energy_kind == 1
            load(sprintf('gr%d_fold_%d.mat',gr,params{i}(1)))   
        elseif energy_kind == 2
            load(sprintf('gr%d_cofold_%d_%d.mat',gr,params{i}(1),params{i}(2))) 
        elseif energy_kind == 3
            load(sprintf('gr%d_fold_%d.mat',gr,params{i}(1))) 
            load(sprintf('gr%d_cofold_%d_%d.mat',gr,params{i}(1),params{i}(2))) 
        end
        for gene = 1:length(group_ind{i})
            right_place = right_places{i}(gene);
            gene_i = group_ind{i}(gene);
            if energy_kind == 1
                energies_vec(right_place) = group_fold_new.Fold{gene_i}(params{i}(2)); 
            elseif energy_kind == 2
                energies_vec(right_place) = group_cofold_new.CoFold{gene_i}(params{i}(3)); 
            elseif energy_kind == 3
                chloro = test_c_for_g(right_place);
                energies_vec(right_place) = group_cofold_new.CoFold{gene_i}(params{i}(3))-params{i}(4)*(group_fold_new.Fold{gene_i}(params{i}(2))+fold_16S2(chloro,params{i}(2)-20+1)); 
            end
            load('vectorized_CAI_rand_test.mat')
        end
    end
    no_nans_vec = energies_vec(~isnan(energies_vec));
    no_nans_CAI = vectorized_CAI(~isnan(energies_vec));
    [corr_cur,~] = corr(no_nans_vec,no_nans_CAI,'Type','Spearman');

    save(sprintf('test_%s_rand%d_%d.mat',energy_name,rand,num_constrains),'energies_vec','corr_cur')
end