function hill_ETIP(iter_start,rand,num)
load('number_groups.mat')
if rand
    if exist(sprintf('res_ETIP_rand1_start%d_%d.mat',iter_start,num))
        load(sprintf('res_ETIP_rand1_start%d_%d.mat',iter_start,num))
        if didnt_improve==500
            exit_code = 1;
        else
            exit_code = -1;
        end
    else
        exit_code = 0;
    end
    % set the random range
    rng(iter_start*5342)
else
    if exist(sprintf('res_ETIP_start%d_%d.mat',iter_start,num))
        load(sprintf('res_ETIP_start%d_%d.mat',iter_start,num))
        if didnt_improve==500
            exit_code = 1;
        else
            exit_code = -1;
        end
    else
        exit_code = 0;
    end
    rng(iter_start*2350)
end
if exit_code~=1
    %% algorithm parameters
    steps = {[25:5:90];[20:45];[1:50];[0:0.5:10]};
    load('group_ind_train.mat'); load('am_genes_train.mat'); load('right_places_train.mat');
    load('train_c_for_g.mat'); % check!!!
    load('fold_16S.mat');
    group_ind = group_ind_train; am_genes = am_genes_train; right_places = right_places_train;    
    %Load CAI Vec~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    if exit_code == 0
        if rand
            load(sprintf('vectorized_CAI_train_rand%d.mat',rand));       
        else
            load('vectorized_CAI_train.mat'); 
        end
        %~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
        %% initialization, selecting 4 options of each parameter
        if num == 0 % with no limitations on the parameters
            steps_start = steps;
            initial_param = [steps{1}(randi(14)),steps{2}(randi(26)),steps{3}(randi(50)),steps{4}(randi(21))];
        else
           mRNA_options_all = {{[]};{[1,8]};{[1,6,10]};{[1,5,8,11]};{[1,4,7,9,12]};{[1,4,6,8,10,12]};{[1,3,5,7,9,11,13]};{[1,3,5,7,8,9,11,13]};{[1,3,5,6,7,8,9,11,13]};{[1,2,3,5,6,7,8,9,11,13]};{[1,3,4,5,6,7,8,9,10,11,13]};{[1,3,4,5,6,7,8,9,10,11,12,13]};{[1,2,3,4,5,6,7,8,9,10,11,12,13]};{[1:14]}};
           s16_options_all = {{[]};{[1,14]};{[1,10,18]};{[1,8,14,20]};{[1,7,12,17,22]};{[1,6,10,14,18,22]};{[1,5,9,13,16,19,23]};{[1,5,8,11,14,17,21,24]};{[1,4,7,10,13,15,18,21,24]};{[1,4,7,10,12,14,16,18,21,24]};{[1,4,7,9,11,13,15,17,19,21,24]};{[1,4,6,8,10,12,14,16,18,20,22,24]};{[1:2:26]};{[1:2:13,14,15:2:26]}};
           pos_options_all = {{[]};{[1,26]};{[1,18,34]};{[1,14,26,38]};{[1,11,21,31,41]};{[1,10,18,26,34,42]};{[1,9,16,23,30,37,44]};{[1,8,14,20,26,32,38,44]};{[1,7,13,18,23,28,33,39,45]};{[1,6,11,16,21,26,31,36,41,46]};{[1,5,9,14,19,24,29,34,39,43,47]};{[1,6,10,14,18,22,26,30,34,38,42,46]};{[1,5,9,13,17,20,23,27,31,35,39,43,47]};{[1,5,9,13,16,19,22,25,28,31,35,39,43,47]}};
           const_options_all = {{[]};{[1,11]};{[1,7,14]};{[1,6,11,16]};{[1,5,9,13,17,21]};{[1,5,8,11,14,18]};{[1,4,7,10,13,16,19]};{[1,4,7,10,12,14,16,19]};{[1,4,6,8,10,12,14,16,19]};{[1,4,6,8,10,12,14,16,18,20]};{[1,3,5,7,9,11,13,15,17,19,20]};{[1,3,5,7,9,10,11,12,14,16,18,20,21]};{[1,3,5,7,9,10,11,12,13,15,17,19,20]};{[1,3,5,7,8,9,10,11,12,13,14,16,18,20]}};
           mRNA_options = mRNA_options_all{num}{1};
           mRNA_l_options = cell(num,1);
           for i = 1:num-1
               mRNA_l_options{i} = steps{1}(mRNA_options(i):mRNA_options(i+1)-1);
           end
           if mRNA_options(end) == 14
              mRNA_l_options{end} = steps{1}(mRNA_options(end-1):14);
           else
               mRNA_l_options{end} = steps{1}(mRNA_options(end):14);
           end
           s16_options = s16_options_all{num}{1};  
           s16_l_options = cell(num,1);
           for i = 1:num-1
               s16_l_options{i} = steps{2}(s16_options(i):s16_options(i+1)-1);
           end
           if s16_options(end) == 26
              s16_l_options{end} = steps{2}(s16_options(end-1):26);
           else
               s16_l_options{end} = steps{2}(s16_options(end):26);
           end
           pos_options = pos_options_all{num}{1};
           pos_l_options = cell(num,1);
           for i = 1:num-1
               pos_l_options{i} = steps{3}(pos_options(i):pos_options(i+1)-1);
           end
           if pos_options(end) == 50
              pos_l_options{end} = steps{3}(pos_options(end-1):50);
           else
               pos_l_options{end} = steps{3}(pos_options(end):50);
           end
           const_options = const_options_all{num}{1};
           const_l_options = cell(num,1);
           for i = 1:num-1
               const_l_options{i} = steps{4}(const_options(i):const_options(i+1)-1);
           end
           if const_options(end) == 21
              const_l_options{end} = steps{4}(const_options(end-1):21);
           else
               const_l_options{end} = steps{4}(const_options(end):21);
           end
           mRNA_L_start = zeros(num,1);
           s16_L_start = zeros(num,1);
           pos_start = zeros(num,1);
           const_start = zeros(num,1);
           for i = 1:num
                mRNA_L_start(i) = mRNA_l_options{i}(randi(length(mRNA_l_options{i})));
                s16_L_start(i) = s16_l_options{i}(randi(length(s16_l_options{i})));
                pos_start(i) = pos_l_options{i}(randi(length(pos_l_options{i})));
                const_start(i) = const_l_options{i}(randi(length(const_l_options{i})));
           end
            steps_start = {mRNA_L_start,s16_L_start,pos_start,const_start};
            initial_param = [mRNA_L_start(randi(num)),s16_L_start(randi(num)),pos_start(randi(num)),const_start(randi(num))]; 
        end
        % initialize the energies vec
        energies_vec_ETIP = zeros(am_genes,1);
        params = cell(number_groups,1);
        for gr = 1:number_groups
            i = gr;
            params{i} = initial_param;
            const = initial_param(4);
            load(sprintf('gr%d_fold_%d.mat',gr,initial_param(1)))
            load(sprintf('gr%d_cofold_%d_%d.mat',gr,initial_param(1),initial_param(2)))  
            for gene = 1:length(group_ind{i})
                right_place = right_places{i}(gene);
                gene_i = group_ind{i}(gene);
                chloro = train_c_for_g(right_place);
                energies_vec_ETIP(right_place) = group_cofold_new.CoFold{gene_i}(initial_param(3))-const*(group_fold_new.Fold{gene_i}(initial_param(3))+fold_16S2(chloro,initial_param(2)-20+1));
            end
        end
        no_nans_vec = energies_vec_ETIP(~isnan(energies_vec_ETIP));
        no_nans_CAI = vectorized_CAI(~isnan(energies_vec_ETIP));
        iter_num=0;
        didnt_improve = 0;
        [corr_cur,~] = corr(no_nans_vec,no_nans_CAI,'Type','Spearman')
    end
    while didnt_improve < 500 % check the stop condition 
          iter_num = iter_num + 1
          group_change = randi(number_groups); % randomly change one group 
          group = group_change;
          param_change = randi(4); % randomly change one parameter
          if num~=0
            am_n = num;
          else
              if param_change == 1
                  am_n = 14;
              elseif param_change == 2
                  am_n = 26;
              elseif param_change == 3
                  am_n = 50;
              elseif param_change == 4
                  am_n = 21;
              end
          end
          corr_neighbor = zeros(am_n,1);
          [neighbors] = create_neighbors(params,group_change,param_change,steps_start,am_n,2);
          energies_vec_ETIP_n = repmat(energies_vec_ETIP,[1,am_n]);
          for n = 1:am_n          
              mRNA_l = neighbors(n,1);
              S16 = neighbors(n,2);
              pos = neighbors(n,3);
              const = neighbors(n,4);
              load(sprintf('/tamir1/stav_carmel/gr_by_names/FEATURES/gr%d_fold_%d.mat',group,mRNA_l))
              load(sprintf('/tamir1/stav_carmel/gr_by_names/FEATURES/gr%d_cofold_%d_%d.mat',group,mRNA_l,S16))             
              %% updating the energies vec
              for gene = 1:length(group_ind{group_change}) % check if can do it in one time
                right_place = right_places{group_change}(gene);
                gene_i = group_ind{group_change}(gene);
                chloro = train_c_for_g(right_place);
                energies_vec_ETIP_n(right_place,n) = group_cofold_new.CoFold{gene_i}(pos)-const*(group_fold_new.Fold{gene_i}(pos)+fold_16S2(chloro,S16-20+1));
              end
              %% corr
              no_nans_vec = energies_vec_ETIP_n(~isnan(energies_vec_ETIP_n(:,n)),n);
              no_nans_CAI = vectorized_CAI(~isnan(energies_vec_ETIP_n(:,n)));
              [n_corr,~]=corr(no_nans_vec,no_nans_CAI,'Type','Spearman');
              corr_neighbor(n)=n_corr;
          end  
          [min_neighbor,which]=min(corr_neighbor);
          if min_neighbor <= (corr_cur-0.001) % it means the correlation got better 
             corr_cur = min_neighbor;
             params{group_change} = neighbors(which,:);
             energies_vec_ETIP = energies_vec_ETIP_n(:,which);
             didnt_improve = 0;
          else
              didnt_improve = didnt_improve + 1;
          end

        if rand
            save(sprintf('res_ETIP_rand%d_start%d_%d.mat',rand,iter_start,num),'iter_num','didnt_improve','corr_cur','energies_vec_ETIP','params','initial_param','steps_start');
        else
            save(sprintf('res_ETIP_start%d_%d.mat',iter_start,num),'iter_num','didnt_improve','corr_cur','energies_vec_ETIP','params','initial_param','steps_start');
        end
    end
    time = toc;
    sprintf('Total time %d\n',time)
end
end
