function [rand_MSA_nt_num,flips] = columns_permute_ORF_codons(MSA_ORF_nt_num, MSA_ORF_AA_num,numAA,numGenes,numAA_noIndel)
good_cols = zeros(numAA,1);
for col = 1:numAA
    if (length(find(MSA_ORF_AA_num(:,col)~= 25 & MSA_ORF_AA_num(:,col)~= 24))*100)/numGenes >= 85
        good_cols(col) = col;
    end
end
good_cols = good_cols(good_cols~=0);
rand_MSA_nt_num = MSA_ORF_nt_num;
count_swaps = 0;
cols_spwapped_check = [];
%pick 2 columns at random 
doContinue=1;
while doContinue
    rand_ind = randperm(length(good_cols));
    rand_cols = good_cols(rand_ind);
    col1 = rand_cols(1);
    col2 = rand_cols(2);
    % check percent similarity and ignore '-' and '*'
    similar_ind = find(MSA_ORF_AA_num(:,col1)==MSA_ORF_AA_num(:,col2));
    match = (length(similar_ind)*100)/numGenes;
    if match >=95 % [%]
       cols_spwapped_check = [cols_spwapped_check;col1,col2];
       ind_rows_switch = similar_ind;
       ind_nt_col1 = col1*3-2:col1*3;
       ind_nt_col2 = col2*3-2:col2*3;
       %switch the rows
       swapped_MSA=rand_MSA_nt_num;
       first=swapped_MSA(ind_rows_switch,ind_nt_col1);
       swapped_MSA(ind_rows_switch,ind_nt_col1) = swapped_MSA(ind_rows_switch,ind_nt_col2);
       swapped_MSA(ind_rows_switch,ind_nt_col2) = first;
       rand_MSA_nt_num = swapped_MSA;
       count_swaps = count_swaps + 1;
       cols_spwap = length(unique(cols_spwapped_check));
       if count_swaps>= 10*numAA_noIndel 
           doContinue = 0;
       end  
    end
end
flips = [count_swaps,10*numAA_noIndel,cols_spwap,numAA_noIndel];
end






