function [rand_MSA_nt_num,flips] = columns_permute_UTR(MSA_UTR_nt_num,numGenes,numNt,L_UTR)
rand_MSA_nt_num = MSA_UTR_nt_num;
flips = [0,0,0,0];
good_cols = zeros(numNt,1);
for col = 1:numNt
    if (length(find(MSA_UTR_nt_num(:,col)~= 16))*100)/numGenes >= 80 
        good_cols(col) = col;
    end
end
good_cols = good_cols(good_cols~=0);
count_swaps = 0;
cols_spwapped_check = [];
cols_amount = L_UTR;
%pick 2 columns at random 
doContinue=1;
if length(good_cols)>=2
    while doContinue
        rand_ind = randperm(length(good_cols));
        rand_cols = good_cols(rand_ind);
        col1 = rand_cols(1);
        col2 = rand_cols(2);
        % check percent not '-' 
        indels_both = find(rand_MSA_nt_num(:,col1)== 16 & rand_MSA_nt_num(:,col2)== 16);  
        nt_ind = find(rand_MSA_nt_num(:,col1)~= 16 & rand_MSA_nt_num(:,col2)~= 16);
        ind_switch = sort([indels_both;nt_ind]);
        percent_switch = (length(ind_switch)*100)/numGenes;
        if percent_switch >= 93 % [%]
           cols_spwapped_check = [cols_spwapped_check;col1,col2];
           %switch the rows
           swapped_MSA=rand_MSA_nt_num;
           first=swapped_MSA(ind_switch,col1);
           swapped_MSA(ind_switch,col1) = swapped_MSA(ind_switch,col2);
           swapped_MSA(ind_switch,col2) = first;
           rand_MSA_nt_num = swapped_MSA;
           count_swaps = count_swaps + 1;
           cols_spwap = length(unique(cols_spwapped_check));
          if count_swaps >= 10*cols_amount
               doContinue = 0;
           end
        end
    end
    flips = [count_swaps,10*cols_amount,cols_spwap,cols_amount];
end
end

