function [MSA_gathered3_rand,MSA_gathered5_rand,MSA_ORF_rand_nt_num,MSA_UTR3_rand_nt_num,MSA_UTR5_rand_nt_num,flips_ORF,flips_UTR3,flips_UTR5] = random_MSA(MSA_ORF_nt_num,MSA_ORF_AA_num,MSA_UTR3_nt_num,MSA_UTR5_nt_num,numAA,numGenes,build_rand_map3,build_rand_map5,numNt3,numNt5,numAA_noIndel,l_UTR3,l_UTR5)

%% ORF random
[MSA_ORF_rand_nt_num,flips_ORF] = columns_permute_ORF_codons(MSA_ORF_nt_num,MSA_ORF_AA_num,numAA,numGenes,numAA_noIndel);
MSA_ORF_rand_nt = cell(numGenes,1); 

%convert the num back into nt and aa
for g = 1:numGenes
    MSA_ORF_rand_nt{g} = int2nt(MSA_ORF_rand_nt_num(g,:));
end


%% UTR random
[MSA_UTR5_rand_nt_num,flips_UTR5] = columns_permute_UTR(MSA_UTR5_nt_num,numGenes,numNt5,l_UTR5);
[MSA_UTR3_rand_nt_num,flips_UTR3] = columns_permute_UTR(MSA_UTR3_nt_num,numGenes,numNt3,l_UTR3);
MSA_UTR5_rand_nt = cell(numGenes,1); 
MSA_UTR3_rand_nt = cell(numGenes,1); 
% convert the num back into nt and aa
for g = 1:numGenes
    MSA_UTR5_rand_nt{g} = int2nt(MSA_UTR5_rand_nt_num(g,:));
    MSA_UTR3_rand_nt{g} = int2nt(MSA_UTR3_rand_nt_num(g,:));
end
%% combine the ORF and UTR and eliminate indel '-'       
MSA_gathered5_rand = cell(numGenes,1);
MSA_gathered3_rand = cell(numGenes,1);
for g = 1:numGenes
    MSA_gathered5_rand{g} = [MSA_UTR5_rand_nt{g}(build_rand_map5{g}{1}),MSA_UTR5_rand_nt{g}(build_rand_map5{g}{2}),MSA_ORF_rand_nt{g}(build_rand_map5{g}{3}),MSA_ORF_rand_nt{g}(build_rand_map5{g}{4})];
    MSA_gathered3_rand{g} = [MSA_ORF_rand_nt{g}(build_rand_map3{g}{1}),MSA_ORF_rand_nt{g}(build_rand_map3{g}{2}),MSA_UTR3_rand_nt{g}(build_rand_map3{g}{3}),MSA_UTR3_rand_nt{g}(build_rand_map3{g}{4})];
end

end

