% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~%
% Shuffle the Zscored CAI and create 50 random Z scored CAI vectors for
% every group
% ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~%

load('number_groups.mat')

for gr = 1:number_groups
    load(sprintf('group%d.mat',gr))
    CAI_zscore_rand = zeros(height(group,50));
    for rand = 1:50
        CAI_Zscore = group.CAI_Zscore;
        CAI_zscore_rand(:,rand) = CAI_Zscore(randperm(length(CAI_Zscore)));
    end
    group.CAI_Zscore_rand = CAI_zscore_rand;
    save(sprintf('group%d.mat',gr),'group')
end