% create chloro num vec for vectorized energy 
load('am_genes_train.mat');
load('am_genes_test.mat');
load('group_ind_train.mat');
load('right_places_train_gr.mat'); 
load('group_ind_test.mat');
load('right_places_test_gr.mat');
load('number_groups.mat')
train_c_for_g = zeros(am_genes_train,1);
test_c_for_g = zeros(am_genes_test,1);
for gr = 1:number_groups
    load(sprintf('gr_feat%d_fold.mat',gr));
    for g = 1:length(group_ind_train{gr_i})
        gene = group_ind_train{gr_i}(g);
        train_c_for_g(right_places_train{gr_i}(g)) = group_fold.C(gene);
    end
    % test:
    for g = 1:length(group_ind_test{gr_i})
        gene = group_ind_test{gr_i}(g);
        test_c_for_g(right_places_test{gr_i}(g)) = group_fold.C(gene);
    end
end
save('train_c_for_g.mat','train_c_for_g')
save('test_c_for_g.mat','test_c_for_g')
    

    